// PLACE YOUR HEADER BLOCK COMMENT HERE

// this class is completely implemented
// no further changes are needed
// but you need to read this code to understand
// how it relates to the list


// LIST_ITR class; maintains "current position"
//
// CONSTRUCTION: Package friendly only, with a LIST_NODE
//
// PUBLIC OPERATIONS:
// bool isPastEnd()      --> True if past end position in list
// void advance()        --> Advance towards tail if not already null
// void retreat()        --> Retreat towards head if not already null
// T retrieve()	         --> Return item in current position


#ifndef LIST_ITR_H
#define LIST_ITR_H

#include <stdlib.h>

template <class T>
class LIST;		// prototype declaration


template <class T>
class LIST_ITR {
	public:
		LIST_ITR();
		bool isPastEnd() const;
		void advance();
		void retreat();

		const T& retrieve() const;
		

	private:
		LIST_NODE<T> *current;    // Current position

		LIST_ITR(LIST_NODE<T> *theNode);

	friend class LIST<T>; // Grant access to constructor
};


template <class T>
LIST_ITR<T>::LIST_ITR()
{
	current = NULL;
}


template <class T>
bool LIST_ITR<T>::isPastEnd() const
{
	return current == NULL;
}


template <class T>
void LIST_ITR<T>::advance()
{
	if(!isPastEnd())
		current = current->next;
}


template <class T>
void LIST_ITR<T>::retreat()
{
	if(!isPastEnd())
		current = current->prev;
}


template <class T>
const T& LIST_ITR<T>::retrieve() const
{
	if (isPastEnd())
	{
		cout << "[LIST_ITR.h : retrieve()] Bad Iterator" << endl;
		cout << "Program Terminated." << endl;
		exit(EXIT_FAILURE);
	}

	return current->element;
}


template <class T>
LIST_ITR<T>::LIST_ITR(LIST_NODE<T> *theNode)
	: current( theNode )
{
}



#endif