// very simple test driver for the list class

#include <iostream.h>

#include "LIST.h"

int main() {

	// create a new LIST of ints named A
	LIST<int> A;

	// insert some values into the list
	for (int i = 1; i <= 7; ++i) {
		A.insertLast(i);
	}

	// define an iterator and find a value in the list
	LIST_ITR<int> position = A.find(4);
	cout << "found: " << position.retrieve() << endl;

	// advance the iterator once, print the value referred to by
	// the iterator
	position.advance();
	cout << "currently at: " << position.retrieve() << endl;

	// retreat the iterator, print retrieved value
	position.retreat();
	cout << "now currently at: " << position.retrieve() << endl;

	// advance the iterator until past the end of the list
	while (!position.isPastEnd())
	{
		cout << "now at: " << position.retrieve() << endl;
		position.advance();
	}

	cout << endl;

	// test display and debugDisplay functions
	// remember we can always define a ofstream object
	// and send our debugging information out that that as well

	A.display(cout);
	cout << endl;

	A.debugDisplay(cout);
	cout << endl;

	A.makeEmpty();
	cout << "check for empty list here: ";
	A.display(cout);
	cout << endl;

	cout << endl;
	cout << "done" << endl;

	return 0;
}
